<?php
namespace Teknisa\MAN\Controllers;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\MAN\Services;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\Report\ReportService;
use Teknisa\MAN\Services\RelControleDeMovimentacaoService;
use Zeedhi\Framework\DTO\Response\Error;   

class RelControleDeMovimentacao  extends  CrudWithParameterBag { 
    
    protected $relatorioService;
    protected $utilService,
              $parameterBagColumns = array('NRORG');
              
    public function __construct ($crudService, $parameterBag, $entityManager, Utilities\Util $utilService, Manager $dataSourceManager,
                                 BirtReport $birtReport, ReportService $reportService, $relatorioService, RelControleDeMovimentacaoService $RelControleDeMovimentacaoService) {
        $this->crudService                        = $crudService;
        $this->parameterBag                       = $parameterBag;
        $this->entityManager                      = $entityManager;
        $this->utilService                        = $utilService;
        $this->dataSourceManager                  = $dataSourceManager;
        $this->birtReport                         = $birtReport;
        $this->reportService                      = $reportService;
        $this->relatorioService                   = $relatorioService;
        $this->RelControleDeMovimentacaoService   = $RelControleDeMovimentacaoService;
    }
    
    public function findRelatorio(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $this->utilService->getParamsAsArray($request);
        $result = $this->RelControleDeMovimentacaoService->controleDeMovimentacaoParamBuild($conditions);
        // print_r($result);die;
        
        $array = array();
        
        foreach($result as $rt){
            $array[$rt['CDFILIAL'].$rt['CDCAIXA']]['UNIDADE'] = $rt['UNIDADE'];
            $array[$rt['CDFILIAL'].$rt['CDCAIXA']]['CAIXA'] = $rt['CDCAIXA'];
            $array[$rt['CDFILIAL'].$rt['CDCAIXA']]['LEGENDA'] = $rt['LEGENDA'];
            
            for($i = 1; $i <= 31; $i++){
                $array[$rt['CDFILIAL'].$rt['CDCAIXA']]['DAY'.$i] = "";
            }
            
        }
        
        foreach($result as $rt){
            $dia = substr($rt['DTDATA'], 0, 2);
            if($dia < 10){
                $dia = (int)$dia;
            }
            $array[$rt['CDFILIAL'].$rt['CDCAIXA']]['DAY'.$dia] = $rt['LEGENDA'];
        }
        
        $teste = array();
        foreach($array as $arr){
            $teste[] = $arr;
        }
        
        $response->addDataSet(new DataSet("orm00031_relControleDeMovimentacao", $teste));
        return $response;
    }
}